<?php

/*
  History:
  v0.9a - Added mail notification to edit item and addItemForm
  v0.10 - Added unInstall()
        - Fixed edit item mail notification
  v0.11 - Fixed form width to size
  v0.12 - Use sql_table, add supportsFeature
  v0.13 - Merged with Adeas's multiple blogs support and better emails code
        - Fixed subscribe/unsubscribe re-direction
  v0.14 - verbaljam's doForm suggestion
        - Added subscribed/unsubscribed message 
        - code indentation
        - subscribe/unsubscribe notice, with link to unsubscribe
  v0.15 - Removed post body from post update notice.... it didn't work in PreUpdateItem event... we need to use PostUpdateItem (not exist currently, tracker opened.)
        - per item comment notification, allow to monitor comments for a post, add <%NotifyMe(itemSub)%> for comment subscription
	- use Bcc: for receiver list
	- send extended body in notification email
	- override sending notification when add new post if it is saved as draft
	- fix XHTML 1.0
	- Added comment notification to author in add/edit item, default option to yes
	- Fixed form action redirection bug
	- Fixed future post bug (ignore future post)
  v0.16 - Added plugin quick menu (currently empty menu)
        - Improved comment subscription email
	- Fixed sql_table
        - Fixed subscribe over subscribe bug (wrong subscribe message sent)
	- Set minimum Nucleus version to 2.5
        - Fixed subscribe/unsubscribe message
  v0.17 - no comment subscription for closed item
        - subscriber management: list all subscription w/ delete action

  admun TODO:
  - tested &$comment passed from the PostAddComment event

  - remove <%image%> tag and such
  - no email when unsubscribe from admin menu
  - notify skin for customisible subscribe/unsubscribe message
  - list subscribers in admin menu

=============

  - delete subscribers from admin management
  - edit subscribers from user or admin management??
  - per blog default notification setting
  - action parameter should be lower case??
  - optimize code, eliminate clone code (ie sending mail)

  - fix FancyURL link
  - add options to various text
  - address blacklist function (need new plugin_notify_block table)

  more idea for dealing with future post...
    - add warning to notice that when this post is available??
    - batch the notification for future post (need NP_Batch... coming in the future)
    - or future post "appearing" event
*/

// to make this plugin works on Nucleus versions <=2.0 as well
if (!function_exists('sql_table'))
{
  function sql_table($name) { return 'nucleus_' . $name; }
}

class NP_NotifyMe extends NucleusPlugin {
    function getMinNucleusVersion() {return 250;} // user reported this is not working in v2.0 somehow....
    function getName() {return 'Notify subscribers by mail';}
    function getAuthor() {return '-=Xiffy=- (Appie Verschoor), mod by Adeas, admun (Edmond Hui)';}
    function getURL() {return 'http://xiffy.nl/weblog/';}
    function getVersion() {return '0.17';}

    function getTableList () {
      return sql_table('plugin_notifyaddress');
    }

    function supportsFeature($feature) {
      switch($feature) {
        case 'SqlTablePrefix':
          return 1;
        default:
          return 0;
      }
    }

    function install() {
      // create the table to hold the addresses ...
      // Table structure: unique key#, blog id#, itemid, email address
      // Note: itemid of 0 == invalid, used as a null value for blog item subscription (cannot be null)
      sql_query('CREATE TABLE IF NOT EXISTS ' .
	  sql_table('plugin_notifyaddress') . 
	  '(id INT NOT NULL PRIMARY KEY AUTO_INCREMENT, 
	    email varchar(100) not null,
	    blogID int(3) not null,
	    itemid int(11) not null)
	    '); 

      $this->createOption('SendEnabled','Is sending notification enabled by default when adding new item?','yesno','yes');
      $this->createOption('SendCommEnabled','Subscribe comment notification for author when adding new item?','yesno','yes');
      $this->createOption('SubscribeButtonText','The caption on the button (label)','text','[Un-] Subscribe');
      $this->createOption('Titleprefix','This will be prefixed to the itemtitle as the title for the email','text','Updated -=Xiffy=- :');
      $this->createOption('updateSender','This is the email address that will be used as the sender','text','updateNotify@xiffy.nl');
      $this->createOption('Formlabel','The label displayed on the form','text','Subscribe for updates');
    }

    function unInstall() {
      sql_query('DROP TABLE '.sql_table('plugin_notifyaddress'));
    }

    // a description to be shown on the installed plugins listing
    function getDescription() {
      return 'This plugin provides a notify me by email function to your blog, which sends the new/edited items to subscribed users. It also supports per blog subscription and per item comment notification.';
    }

    // subscribe to PostAddItem and AddItemFormExtras
    function getEventList() {
      return array('PreAddItem', 'PostAddItem', 'PreUpdateItem', 'AddItemFormExtras','EditItemFormExtras', 'PostAddComment', 'QuickMenu');
    }

    function hasAdminArea() {
      return 1;
    }

    function event_QuickMenu(&$data) {
      global $member;
      if (!($member->isLoggedIn() && $member->isAdmin())) return;

      array_push(
	  $data['options'],
	  array(
	    'title' => 'Notification Management',
	    'url' => $this->getAdminURL(),
	    'tooltip' => 'Manage comment/blog notification subscription.'
	    )
	  );
    }

    function event_PreAddItem($data) {
      $this->itime = $data['timestamp'];
      $this->draft = "no";

      if ($data['draft'] == '1') {
        $this->draft = "yes";
      }
    }

    // Send mail notification when new item added
    function event_PostAddItem($data) {
      global $manager, $CONF, $blog;

      $query=mysql_query('SELECT iblog,iauthor FROM '.    // pulls the blog ID# from the mySQL database
	  sql_table('item').                      // Thanks Radek for the code 
	  ' WHERE inumber='.$data['itemid']); 
      $row=mysql_fetch_object($query); 
      $IDnum=$row->iblog; 
      $author=$row->iauthor;
      $query=mysql_query('SELECT bname FROM '. 
	  sql_table('blog'). 
	  ' WHERE bnumber='.$IDnum); 
      $row=mysql_fetch_object($query); 
      $BlogName=$row->bname; 

      $send_email = requestVar('send_email');
      $sub_comm = requestVar('sub_comm');
      if ($sub_comm == "on") {
	$mem = new MEMBER;
	$mem->readFromID($author);
	$a_email = $mem->getEmail();

	$query = "INSERT INTO ".sql_table('plugin_notifyaddress')." (id, email, blogID, itemid) VALUES ('NULL', '" . $a_email .  "', '" . $IDnum . "', '" . $data['itemid'] . "')";
	sql_query($query);
      }

      $future = "no";
      $time = strftime("%Y-%m-%d %H:%M:%S", time());
      if ($this->itime > $time) $future = "yes";
      
      if ($send_email == "on" && $this->draft == "no" && $future == "no") {

	// get a handle to notify object
	// add all email adress to a semicolon seperated list ..
	$emailquery = "SELECT email FROM ".sql_table('plugin_notifyaddress')." WHERE blogID='" .$IDnum. "' AND itemid='0'"; 
	$address = mysql_query($emailquery);
	$list = $row->email;
	while ($row = mysql_fetch_object($address)){
	  $list .= "," . $row->email;
	}

	$itemid = $data['itemid'];
	$item =& $manager->getItem($itemid, 0, 0);
	$title = $this->getOption('Titleprefix') ." ". stripslashes($item['title'])." - ".$BlogName; 
	$body = "<h3>".stripslashes($item['title'])."</h3>"; 
	$body .= stripslashes($item['body']); 
	$body .= "<br />". stripslashes($item['more']); 
	$url = $CONF['IndexURL'] .createItemLink($itemid); 
	$body .= "<p />URL: <a href=\"".$url."\">".$url."</a>"; 
	$sender = $this->getOption('updateSender'); 

	// email notification 
	$headers = "Content-type: text/html; charset=iso-8859-1\n"; 
	$headers .= "From: ".$sender."\n"; 
	$headers .= "Bcc: ".$list."\n"; 
	$headers .= "X-Mailer: PHP/" . phpversion(); 

        $return = mail("",$title,$body,$headers); 
      } 
    }

    // Send mail notification when item edited
    function event_PreUpdateItem($data) {
      global $manager, $CONF, $blog;

      $query=mysql_query('SELECT iblog,iauthor FROM '.    // pulls the blog ID# from the mySQL database
	  sql_table('item').                      // Thanks Radek for the code 
	  ' WHERE inumber='.$data['itemid']); 
      $row=mysql_fetch_object($query); 
      $IDnum=$row->iblog; 
      $author=$row->iauthor;
      $query=mysql_query('SELECT bname FROM '.
	  sql_table('blog'). 
	  ' WHERE bnumber='.$IDnum); 
      $row=mysql_fetch_object($query); 
      $BlogName=$row->bname; 

      $send_email = requestVar('send_email');
      $sub_comm = requestVar('sub_comm');
      if ($sub_comm == "on") {
	$mem = new MEMBER;
	$mem->readFromID($author);
	$a_email = $mem->getEmail();

	$query = "SELECT * FROM ".sql_table('plugin_notifyaddress')." WHERE email='" . $a_email . "' AND itemid=" . $data['itemid'];
	$res = sql_query($query);

	// Do not add email address if already exist.... maybe should use ignore from MySQL 4.1.*??
	if (mysql_num_rows($res) == 0) {
	  $query = "INSERT INTO ".sql_table('plugin_notifyaddress')." (id, email, blogID, itemid) VALUES ('NULL', '" . $a_email .  "', '" . $IDnum . "', '" . $data['itemid'] . "')";
	  sql_query($query);
	}
      }

      // if this event occurs, send an email to all subscribers
      if ($send_email == "on") {
	// get a handle to notify object
	// add all email adress to a semicolon seperated list ..
	$emailquery = "SELECT email FROM ". sql_table('plugin_notifyaddress') . " WHERE blogID = '" .$IDnum. "' AND itemid='0'"; 
	$address = mysql_query($emailquery);
	$row = mysql_fetch_object($address);
	$list = $row->email;
	while ($row = mysql_fetch_object($address)){
	  $list .= "," . $row->email;
	}

	// Note: It would be nice to be able to include the message in the email, but there is no PostUpdateItem event....
	$itemid = $data['itemid'];
	$ititle = $data['title'];
	$title = $this->getOption('Titleprefix') . stripslashes($ititle)." - ".$BlogName; 
	$body  = '"' .stripslashes($ititle). '" has been updated.<p />';
	$url   = $CONF['IndexURL'] .createItemLink($itemid); 
	$body .= "<p />URL: <a href=\"".$url."\">".$url."</a>"; 
	$sender = $this->getOption('updateSender'); 

	// email notification 
	$headers = "Content-type: text/html; charset=iso-8859-1\n"; 
	$headers .= "From: ".$sender."\n"; 
	$headers .= "Bcc: ".$list."\n"; 
	$headers .= "X-Mailer: PHP/" . phpversion(); 

	$return = mail("",$title,$body,$headers); 
      }
    }

    // add the option send / not send email during item edit...
    function event_EditItemFormExtras($data) {
      $on = $this->getOption('SendEnabled');
      ?>
	<h3>NotifyMe</h3>

			<p>
				<input type="checkbox" id="plug_send_email" name="send_email" />
				<label for="plug_send_email">Send notification to subscribers</label>
			<br />
				<input type="checkbox" <? if ($con=="yes") { echo 'checked="checked"';} ?> id="plug_send_comm_email" name="sub_comm" />
				<label for="plug_send_comm_email">Subscribe to comment notification</label>
			</p>
		<?
	}

    // add the option send / not send email ...
    function event_AddItemFormExtras($data) {
      $on = $this->getOption('SendEnabled');
      $con = $this->getOption('SendCommEnabled');
      ?>
	<h3>NotifyMe</h3>

			<p>
				<input type="checkbox" <? if ($on=="yes") { echo 'checked="checked"';} ?> id="plug_send_email" name="send_email" />
				<label for="plug_send_email">Send notification to subscribers</label>
			<br />
				<input type="checkbox" <? if ($con=="yes") { echo 'checked="checked"';} ?> id="plug_send_comm_email" name="sub_comm" />
				<label for="plug_send_comm_email">Subscribe to comment notification</label>
			</p>
		<?
	}

    function event_PostAddComment($comment) {
      $emailquery = "SELECT email FROM ".sql_table('plugin_notifyaddress')." WHERE itemid='".$comment['comment']['itemid']."'"; 
      $address = mysql_query($emailquery);
      $list = $row->email;
      while ($row = mysql_fetch_object($address)){
	$list .= "," . $row->email;
      }

      global $CONF, $manager, $blog;
      $blog =& $manager->getBlog(getBlogIDFromItemID($comment['comment']['itemid']));
      if (!$CONF['ItemURL']) $CONF['ItemURL'] = $blog->getURL();
      $title = $this->getOption('Titleprefix') ." - new comment for " . $blog->getName(); 
      $body  = "A new comment has been made to an item:<br />"; 
      $body  .= stripslashes($comment['comment']['body']) . "<br />"; 
      $url   = createItemLink($comment['comment']['itemid']); 
      $body .= "<p />URL: <a href=\"".$url."\">".$url."</a>"; 
      $sender = $this->getOption('updateSender'); 

      // email notification 
      $headers = "Content-type: text/html; charset=iso-8859-1\n"; 
      $headers .= "From: ".$sender."\n"; 
      $headers .= "Bcc: ".$list."\n"; 
      $headers .= "X-Mailer: PHP/" . phpversion(); 

      $return = mail("",$title,$body,$headers); 
    
      /*
      ED$ BEBUGGING CODE - to be removed
      $body = $comment['comment']['user'].','.$comment['comment']['userid'].','.$comment['comment']['userid'].','.$comment['comment']['body'].','.$comment['comment']['host'].','.$comment['comment']['ip'].','.$comment['comment']['memberid'].','.$comment['comment']['timestamp'].','.$comment['comment']['itemid'].','.$comment['comment']['blogid'].','.$list;

      $headers = "Content-type: text/html; charset=iso-8859-1\n"; 
      $headers .= "From: root@localhost\n"; 
      $headers .= "X-Mailer: PHP/" . phpversion(); 

      $return = mail('root@localhost','PostAddComment result',$body,$headers); 
      */
    }

    // action handling
    function doAction($actionType) {
      global $CONF, $blog, $manager;

      $email = requestVar('emailaddress');

      // Show the subscriber login form
      if ($actionType == "subadmin") {
	echo "Please enter the email address and access key (provided in the subscription email)"
	. "<form method=\"post\" action=\"".$CONF['ActionURL']."\" />\n" 
	. "<input type=\"hidden\" name=\"action\" value=\"plugin\" />\n" 
	. "<input type=\"hidden\" name=\"name\" value=\"NotifyMe\" /> \n" 
	. "<input type=\"hidden\" name=\"type\" value=\"subadmin2\" /> \n" 
	. "Email: <input type=\"text\" name=\"emailaddress\" value=\"\" /><br/>\n" 
	. "Access Key: <input type=\"text\" name=\"key\" value=\"\" /><br/>\n" 
	. "<input type=\"submit\" class=\"button\" value=\"Submit\" />"
	. "</form>\n";
        return;
      } 

      // Show the list of subscription for a subscriber
      if ($actionType == "subadmin2") {
        $key = requestVar('key');

        $query = "SELECT * FROM ".sql_table('plugin_notifyaddress')." WHERE email = '" .$email."' AND id = '" . $key . "'";
        $result = mysql_query($query); 
	if (mysql_num_rows($result) < 1) {
	  echo "Login failed, invalid email/key";
	  return;
	}

        echo "<h2>Notification Management</h2>";
	echo "Here's a list of all notification subscriptions for " . $email . ":<br/>";

        $query = "SELECT * FROM ".sql_table('plugin_notifyaddress')." WHERE email = '" .$email."'";
        $rows = mysql_query($query); 
	echo "<table>\n";
	echo "<td>Name</td><td>Type</td><td></td>";
        while($row = mysql_fetch_object($rows)) {
	  $redirecturl = 'noredirect';
	  echo "<tr>";
	  if ($row->itemid == 0) {
	    $delAction = $CONF['ActionURL'] . '?action=plugin&name=NotifyMe&type=form&emailaddress=' . $row->email
	      . '&redirecturl=' . $redirecturl . '&currBlogId=' . $row->blogID;
	    echo "<td><a href=\"./". createBlogidLink($row->blogID) . "\">" . getBlogNameFromID($row->blogID) .
	    "</a></td><td>Blog</td><td>[<a href=\"".$delAction."\">delete</a>]</td>\n";
	  } else {
	    $item =& $manager->getItem($row->itemid, 0, 0);
	    $delAction = $CONF['ActionURL'] . '?action=plugin&name=NotifyMe&type=form&emailaddress=' . $row->email
	      . '&redirecturl=' . $redirecturl . '&currBlogId=' . $row->blogID . '&itemid=' . $row->itemid;
	    echo "<td><a href=\"". createItemLink($row->itemid) ."\">". $item['title'] . "</a></td><td>Item (".$row->itemid.")</td><td>[<a href=\"".$delAction."\">delete</a>]</td>\n";
	  }
	  echo "</tr>";
	}
	echo "</table>\n";

        return;
      }

      // Defualt subscribe/unsubscribe action
      $IDnum = intRequestVar('currBlogId'); // IDnum = 0 if no such var
      $redirect = requestVar('redirecturl');
      $itemid = intRequestVar('itemid'); // itemid = 0 if no such var

      if ($itemid == '0') {
	$subType = 'blogSub';
      } else {
	$subType = 'itemSub';
      }

      $pluginquery = "SELECT email FROM ".sql_table('plugin_notifyaddress')." WHERE email= '" .$email. "' AND itemid='".$itemid."' and itemid='" . $itemid . "'";
      $check = mysql_query($pluginquery); // no errors please ...

      if (mysql_num_rows($check) == 0) {
	// new subscriber, Welcome ...
	$ok = isValidMailAddress($email);
	if ($ok) {
	  $actionquery = "INSERT INTO ".sql_table('plugin_notifyaddress')." (id, email, blogID, itemid) VALUES ('NULL', '" . $email .  "', '" . $IDnum . "', '" . $itemid . "')";
	  $sub = 0;
	} else {
	  return ("This is not a valid email address!");
	}
      } else {
	// sorry to see you go ...
	$actionquery = "DELETE FROM ".sql_table('plugin_notifyaddress')." WHERE email = '" .$email . "' AND blogID='" .$IDnum ."' AND itemid='" . $itemid . "'";
	$sub = 1;
      }

      // execute actionquery
      mysql_query($actionquery);

      // send subscription notice only if we're doing it from the form, skip email if it is from email's link
      $blogName = getBlogNameFromID($IDnum);
      if ($redirect != 'noredirect') {
	$sender = $this->getOption('updateSender');
	if ($sub == '0') {
	  $title = "$blogName - NotifyMe subscription";
	  if ($subType == 'itemSub') {
	    $item =& $manager->getItem($itemid, 0, 0);
	    $ititle = $item['title'];
	    $unSubLink = $CONF['ActionURL'] . '?action=plugin&name=NotifyMe&type=form&emailaddress=' . $email
	      . '&redirecturl=noredirect&currBlogId=' . $IDnum . '&itemid=' . $itemid;
	    $body = 'Dear ' . $email . ',<p />Thanks for subscribing to "' . $ititle . '".<p />'
	      . 'To unsubscribe from this blog, click: <a href="' . $unSubLink . '">' . $unSubLink . '</a>';
	  } else {
	    $unSubLink = $CONF['ActionURL'] . '?action=plugin&name=NotifyMe&type=form&emailaddress=' . $email
	      . '&redirecturl=noredirect&currBlogId=' . $IDnum;

	    $query = "SELECT id FROM ". sql_table('plugin_notifyaddress') . " WHERE email='".$email."' AND blogID = ".$IDnum." AND itemid = ".$itemid;
	    $res = mysql_query($query);
	    $idkey = mysql_fetch_object($res);
	    $accesskey = $idkey->id;
	    $manLink = $CONF['ActionURL']."?action=plugin&name=NotifyMe&type=subadmin";
	    $body = 'Dear ' . $email . ',<p />Thanks for subscribing to ' . $blogName . '.<p />'
	      . "Subscription information:<p />email address: " . $email . "<p />"
	      . "access key: ". $accesskey . "<p />"
	      . 'To unsubscribe from this blog: <a href="' . $unSubLink . '">' . $unSubLink . '</a><p />'
	      . 'To manage all subscriptions: <a href="' .$manLink . '">here</a>';
	  }
	} else {
	  $title = "$blogName - NotifyMe unsubscription";
	  if ($subType == 'itemSub') {
	    $item =& $manager->getItem($itemid, 0, 0);
	    $ititle = $item['title'];
	    $body = 'Dear ' . $email . ',<p />You\'re now unsubscribed from "' . $ititle . '".';
	  } else {
	    $body = 'Dear ' . $email . ',<p />You\'re now unsubscribed from ' . $blogName . '.';
	  }
	}

	$headers = "Content-type: text/html; charset=iso-8859-1\n"; 
	$headers .= "From: ".$sender."\n"; 
	$headers .= "X-Mailer: PHP/" . phpversion(); 

	$return = mail($email,$title,$body,$headers);

	// strip parameters from previous action...
	$redirect = preg_replace("/\?.subscribe=./", "", $redirect);
	$redirect = preg_replace("/.subscribe=./", "", $redirect);
	$redirect = preg_replace("/&subtype=(itemSub|blogSub)/", "", $redirect);
	$redirect = preg_replace("/&add=(.*)/", "", $redirect);

	if (strstr('?', $redirect) == '') {
	  $sub_string = "?&subscribe=";
	} else {
	  $sub_string = "subscribe=";
	}

        header('Location: ' . $redirect . $sub_string . $sub . '&subtype=' . $subType . '&add=' . $email);
      }
      else {
        echo "You are now unsubscribed from $blogName";
      }
    }

    // generate the subscribe box, and display subscription status
    function doSkinVar($skinType, $form) {
      global $manager, $blog, $CONF, $DIR_PLUGINS;

      $ButtonCaption = $this->getOption('SubscribeButtonText');
      $Formlabel     = $this->getOption('Formlabel');		
      $currBlogId    = $blog->getID(); 
      $sub           = RequestVar('subscribe');
      $add           = RequestVar('add');
      $subType       = RequestVar('subtype');
      if ($form == '') $form = 'blogSub';

      $this->doForm($ButtonCaption,$Formlabel,$currBlogId,$sub,$add,$form,$subType);
    }

    // HTML Functions
    function doForm($ButtonLabel,$Label, $currBlogId, $sub, $add, $form,$subType) {
        global $CONF, $itemid, $manager;


	// echo "sub=" . $sub . " subType=" . $subType . " form=" . $form . "</br>";

	  if ($form == 'itemSub') {
            $item =& $manager->getItem($itemid, 0, 0);
	    if ($item['closed'] == '1') {
	      return;
	    }

	    echo "<h2>Subscribe to Item Comment</h2>";
	  }

	  // display subscribe/unsubscribe message
	  if ($sub != '' && $subType != '' && $subType == $form) {
	    if ($sub == '0')
	      $message = '<i>Thank you, ' . $add . ' subscribes successfully</i><br /><br />';
	    else if ($sub == '1')
	      $message = '<i>Thank you, ' . $add . ' unsubscribes successfully</i><br /><br />';
	    else
	      $message = '<i>No action perfromed</i><br />';

	    echo $message;
	  }

	  $redirect = serverVar('REQUEST_URI');

	  if ($form == 'itemSub') {
	    echo "<div class=\"NotifyMe\">\n" 
	      . "Enter email address to subscribe to comment on this item<br />"
	      . "<form method=\"post\" action=\"".$CONF['ActionURL']."\" />\n" 
	      . "<input type=\"hidden\" name=\"action\" value=\"plugin\" />\n" 
	      . "<input type=\"hidden\" name=\"name\" value=\"NotifyMe\" /> \n" 
	      . "<input type=\"hidden\" name=\"type\" value=\"form\" /> \n" 
	      . "<input type=\"text\" id=\"xp\" name=\"emailaddress\" value=\"@\" />\n" 
	      . "<input type=\"hidden\" name=\"redirecturl\" value=\"" .  $redirect . "\" />" 
	      . "<input type=\"hidden\" name=\"currBlogId\" value=\"" .$currBlogId . "\" />" 
	      . "<input type=\"hidden\" name=\"itemid\" value=\"" . $itemid .  "\" />"
	      . "<input type=\"submit\" class=\"button\" value=\"Subscribe to this Item\" />"
	      . "</form>"
	      . "</div>\n"; 
	  } else {
	    echo "<div class=\"NotifyMe\">\n" 
	      . "<form method=\"post\" action=\"".$CONF['ActionURL']."\" />\n" 
	      . "<input type=\"hidden\" name=\"action\" value=\"plugin\" />\n" 
	      . "<input type=\"hidden\" name=\"name\" value=\"NotifyMe\" /> \n" 
	      . "<input type=\"hidden\" name=\"type\" value=\"form\" /> \n" 
	      . $Label 
	      . "<input type=\"text\" id=\"xp\" name=\"emailaddress\" value=\"@\" />\n" 
	      . "<input type=\"hidden\" name=\"redirecturl\" value=\"" .$redirect . "\" />" 
	      . "<input type=\"hidden\" name=\"currBlogId\" value=\"" .$currBlogId . "\" />" 
	      . "<input type=\"submit\" class=\"button\" value=\"" .$ButtonLabel ."\" />"
	      . "</form>"
	      . "</div>\n"; 
	  }

	    echo "<a href=\"" . $CONF['ActionURL'] . "?action=plugin&name=NotifyMe&type=subadmin\">Click here to manage subscription</a>";
    }
}
?>
